#include <windows.h>
#include <stdio.h>
#include <sys\stat.h>
#define MAX_SIZE 12288
void usage()
{
	printf("Usage: LanguageBuild Project Media Language\n");
	printf("Where:\tProject is the name of the InstallShield project *\n");
	printf("\tMedia is the name of the media to be changed *\n");
	printf("\tLanguage is the language to which the media will be set\n");
	printf("* Enclosed in double quotes (\") if they contain spaces\n");
	printf("\nExamples:\n\tLanguageBuild \"My Application\" \"Default Media\" 0009\n");
	printf("\tLanguageBuild \"My Application\" Default 0013\n");
	printf("\tLanguageBuild \"My Application\" \"My Media\" 040c\n");
	printf("\tLanguageBuild \"My Application\" Client 0009\n");

}

void main(int argv, char *argc[])
{
	char szFileName[_MAX_PATH];
	char szKey[_MAX_PATH];
	char szLocation[_MAX_PATH];
	//char temp[_MAX_PATH];
	HKEY hKey;
	DWORD dwSize;
	
	if (argv < 5) { // usually called without passing in location
		if (argv < 4) {
			usage();
			exit(1);
		}
		sprintf(szKey, "SOFTWARE\\InstallShield\\InstallShield Professional");
		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szKey, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS) {
			MessageBox(NULL, "Unable to open InstallShield key in registry", "LanguageBuild - Error", MB_OK);
			exit (-1);
		}
		if (RegOpenKeyEx(hKey, "5.5", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS) {
			if (RegOpenKeyEx(hKey, "5.1", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS) {
				if (RegOpenKeyEx(hKey, "5.0", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS) {
					MessageBox(NULL, "Unable to determine InstallShield version from registry", "LanguageBuild - Error", MB_OK);
					exit (-1);
				}
			}
		}
		if (RegOpenKeyEx(hKey, "Main", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS) {
			MessageBox(NULL, "Unable to open registry key", "LanguageBuild - Error", MB_OK);
			exit (-1);
		}
		dwSize = sizeof(szLocation);
		if (RegQueryValueEx(hKey, "DataFile", NULL, NULL, szLocation, &dwSize) != ERROR_SUCCESS) {
			MessageBox(NULL, "Unable to read registry value", "LanguageBuild - Error", MB_OK);
			exit (-1);
		}
	}
	else { //undocumented feature.  Can pass in location of projects.
		strcpy(szLocation, argc[4]);
	}
	sprintf(szFileName, "%s\\%s\\Media\\%s\\default.mda", szLocation, argc[1], argc[2]);
	//sprintf(temp,"Calling with (Filter, LANGUAGEDEFAULT, %s, %s) and\n with (Languages, key0, %s, %s)", argc[3], szFileName, argc[3], szFileName);
	//MessageBox(NULL, temp, "WritePrivateProfileString", MB_OK);
	WritePrivateProfileString("Filter", "LANGUAGEDEFAULT", argc[3], szFileName);
	WritePrivateProfileString("Languages", "key0", argc[3], szFileName);
}